<?php
/**
* Joomla Community Builder User Plugin: plug_activityindex
* @version $Id$
* @package plug_activityindex
* @subpackage activityindex.php
* @author Daniel Scheufler
* @copyright (C) 2007 Daniel Scheufler, www.joomla-fortbildung.de
* @license Limited http://www.gnu.org/copyleft/gpl.html GNU/GPL
* @final 1.0
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );


/**
 * Basic tab extender. Any plugin that needs to display a tab in the user profile
 * needs to have such a class. Also, currently, even plugins that do not display tabs (e.g., auto-welcome plugin)
 * need to have such a class if they are to access plugin parameters (see $this->params statement).
 */
class getactivityindexTab extends cbTabHandler {
	/**
	 * Construnctor
	 */
	function getactivityindexTab() {
		$this->cbTabHandler();
	}
    
    function aigetLastUpdateDiff ($id) {
        global $database;
        $query = "SELECT DATEDIFF(CURDATE(), lastupdatedate)"
                ."\n FROM #__comprofiler"
                ."\n WHERE id=" . (int) $id;
        $database->setQuery($query);
        $ailastupdatediff = $database->loadResult();
        return $ailastupdatediff;
    }
    
    function aigetLastOnlineDiff ($id) {
        global $database;
        $query = "SELECT DATEDIFF(CURDATE(), lastvisitdate)"
            ."\n FROM #__users"
            ."\n WHERE id=" . (int) $id;
        $database->setQuery($query);
        $ailastonlinediff = $database->loadResult();
        return $ailastonlinediff;
    }
    
    function aigetConnectionsLastMonth ($id) {
    global $database;
        $query = "SELECT COUNT(*)"
                ."\n FROM #__comprofiler_members"
                ."\n WHERE referenceid=" . (int) $id
                ."\n AND accepted=1"
                ."\n AND pending=0"
                ."\n AND DATE_SUB(CURDATE(),INTERVAL 90 DAY) <= membersince";
        $database->setQuery($query);
        $aiconnectionslastmonth = $database->loadResult();
        return $aiconnectionslastmonth;
        
    }
    
    function aigetFbEntriesLastMonth ($id) {
        global $database;
        $query = "SELECT COUNT(*)"
            ."\n FROM #__fb_messages"
            ."\n WHERE userid=" . (int) $id
            ."\n AND DATE_SUB(CURDATE(),INTERVAL 90 DAY) <=  FROM_UNIXTIME(time)";
        $database->setQuery($query);
        $aifbentrieslastmonth = $database->loadResult();
        return $aifbentrieslastmonth;
    }
    
    function aigetGbEntriesLastMonth ($id) {
        global $database;
        $query = "SELECT COUNT(*)"
                ."\n FROM #__comprofiler_plug_profilebook"
                ."\n WHERE posterid=" . (int) $id
                ."\n AND DATE_SUB(CURDATE(),INTERVAL 90 DAY) <= date";
        $database->setQuery($query);
        $aigbentrieslastmonth = $database->loadResult();
        return $aigbentrieslastmonth;
    }
    
    function aigetProfileViewsLastMonth ($id) {
        global $database;
        $query = "SELECT COUNT(*)"
                ."\n FROM #__comprofiler_views"
                ."\n WHERE viewer_id=" . (int) $id
                ."\n AND DATE_SUB(CURDATE(),INTERVAL 90 DAY) <= lastview";
        $database->setQuery($query);
        $aiprofileviewslastmonth = $database->loadResult();
        return $aiprofileviewslastmonth;
    }   

    function getMenuAndStatus($tab,$user,$ui) {
        global $database, $mainframe, $my;

        
        //Check if User was Online
        if ($user->lastvisitDate == "0000-00-00 00:00:00")
        {
            $airesult = 0;
        }
        else
        {
            
            // get parameters
            $params = $this->params;
            $ailabel                = $params->get('ailabel', "Activity Index");
            $aitooltip              = $params->get('aitooltip', "Shows the activity of an user");
            $aigbfactor             = $params->get('aigbfactor', "25");
            $aiprofilefactor        = $params->get('aiprofilefactor', "25");
            $aiconnectionsfactor    = $params->get('aiconnectionsfactor', "25");
            $aifbfactor             = $params->get('aifbfactor', "25");
            $ailastonlinefactor     = $params->get('ailastonlinefactor', "2");
            $ailastupdatefactor     = $params->get('ailastupdatefactor', "0.2");
            
            $aigbtarget             = $params->get('aigbtarget', "25");
            $aiprofiletarget        = $params->get('aiprofiletarget', "25");
            $aiconnectionstarget    = $params->get('aiconnectionstarget', "25");
            $aifbtarget             = $params->get('aifbtarget', "25");
            
            //Check Lastupdate Difference
            if ($ailastupdatefactor > 0)
            {
                if ($user->lastupdateDate == "0000-00-00 00:00:00")
                {
                    $ailastupdatediff = 100;
                }
                else
                {
                    $ailastupdatediff = $this->aigetLastUpdateDiff($user->id);
                }
                $ailastupdate   = $ailastupdatediff * $ailastupdatefactor;
            }
            else $ailastupdate = 0;
            
            //Calculate Lastonline Difference
            if ($ailastonlinefactor > 0)
            {
                $ailastonlinediff = $this->aigetLastOnlineDiff($user->id);
                $ailastonline = $ailastonlinediff * $ailastonlinefactor;
            }
            else $ailastonline = 0;
            
            //Calculate GB Entries Last 90 Days
            if (file_exists( $mainframe->getCfg('absolute_path').'/components/com_comprofiler/plugin/user/plug_cbprofilebook/cb.profilebook.php' )
                    and $aigbfactor > 0 and $aigbtarget > 0)
            {
                 $aigbentrieslastmonth = $this->aigetGbEntriesLastMonth($user->id);
                 $aigb = $aigbentrieslastmonth/$aigbtarget * $aigbfactor;
                 if ($aigb > $aigbfactor)
                 {
                    $aigb = $aigbfactor;
                 }
            }          
            else $aigb = 0;
            
            //Calculate Profile Views Last 90 Days
            if ($aiprofilefactor > 0 and $aiprofiletarget > 0)
            {
                $aiprofileviewslastmonth = $this->aigetProfileViewsLastMonth($user->id);
                $aiprofile = $aiprofileviewslastmonth/$aiprofiletarget * $aiprofilefactor;
                if ($aiprofile > $aiprofilefactor)
                {
                   $aiprofile = $aiprofilefactor;
                }                
            }
            else $aiprofile = 0;
            
            //Calculate Connections Last 90 Days
            if ($aiconnectionsfactor > 0 and $aiconnectionstarget > 0)
            {
                $aiconnectionslastmonth = $this->aigetConnectionsLastMonth($user->id);
                $aiconnections = $aiconnectionslastmonth/$aiconnectionstarget * $aiconnectionsfactor;
                if ($aiconnections > $aiconnectionsfactor)
                {
                   $aiconnections = $aiconnectionsfactor;
                }   
            }
            else $aiconnections = 0;
            
            //Check FB Entries Last 90 Days
            if (file_exists( $mainframe->getCfg('absolute_path').'/components/com_fireboard/fireboard.php' )
                    and $aifbfactor > 0 and $aifbtarget > 0)
            {
            $absolutpath=$mainframe->getCfg('absolute_path');
                $aifbentrieslastmonth = $this->aigetFbEntriesLastMonth($user->id); 
                $aifb = $aifbentrieslastmonth/$aifbtarget * $aifbfactor;
                if ($aifb > $aifbfactor)
                {
                   $aifb = $aifbfactor;
                } 
            }
            
            //Result
            $airesult = floor($aigb + $aiprofile + $aiconnections + $aifb - $ailastonline- $ailastupdate);
            if ($airesult > 100)
            {
                $airesult = 100;
            }
            
            if ($airesult < 0)
            {
                $airesult = 0;
            }
        }   
        
        //Html Output
        $airesulthtml = "<table style='float:left; margin-right:5px;margin-top:2px; border-width:thin;" .
                                    "border-style:solid; border-color:#CCCCCC;'" .
                                    "cellspacing='1' cellpadding='0' width='60%' >
                        <tr>
                            <td width='<?php $airesult ?>%' height='7px' bgcolor='#0066CC'>
                            </td>
                            <td width='<?php 100-$airesult ?>%' height='7px' style='background-color:transparent;''>
                           </td> 
                        </tr>
                    </table>$airesult%";
                    
        $mi = array(); $mi["_UE_MENU_STATUS"][$ailabel][$ailabel]=null;
        $this->addMenu( array(  "position"  => "menuList" ,     // "menuBar", "menuList"
                                "arrayPos"  => $mi ,
                                "caption"   => $airesulthtml,
                                "url"       => "" ,     // can also be "<a ....>" or "javascript:void(0)" or ""
                                "target"    => "" , // e.g. "_blank"
                                "img"       => null ,   // e.g. "<img src='plugins/user/myplugin/images/icon.gif' width='16' height='16' alt='' />"
                                "alt"       => null ,   // e.g. "text"
                                "tooltip"   => $aitooltip,
                                "keystroke" => null ) );    // e.g. "P"
    
        return true;
        
    } // end of getMenuAndStatus function
    
} // end of gethelloworldTab class
?>